unit PQUniUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, StrUtils;

type
  TPQUni = class(TForm)
    Label1: TLabel;
    Memo1: TMemo;
    Label2: TLabel;
    Memo2: TMemo;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Label5: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Label6: TLabel;
    procedure Memo1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  PQUni: TPQUni;

implementation

{$R *.dfm}

procedure TPQUni.Memo1Change(Sender: TObject);
var
        wc:WideChar;
        ws:WideString;
        wslen:Integer;
        i:Integer;
        result:AnsiString;
begin
        ws := WideString(Memo1.Text);
        wslen := Length(ws);
        result := '';
        for i := 1 to wslen do
        begin
                wc := ws[i];
                if Integer(wc)> 32 then
                begin
                        result := result
                                + AnsiString(wc)
                                + #9
                                + IntToStr(Integer(wc))
                                + #9 + '0x'
                                + IntToHex(Integer(wc), 8)
                                + #13#10;
                end;
        end;
        Memo2.Text := result;
end;

procedure TPQUni.Button1Click(Sender: TObject);
begin
        Close;
end;

procedure TPQUni.Edit1Change(Sender: TObject);
var
        s:AnsiString;
        slen:Integer;
        i, code, mode:Integer;
begin
        s := Edit1.Text;
        if '0x' = PChar(MidStr(s, 0, 2)) then
        begin
                Val(s,code,i);
        end
        else
        begin
                slen := Length(s);
                mode := 10;
                for i := 1 to slen do
                begin
                        code := Integer(s[i]);
                        if (code<Ord('0')) or (code>Ord('9')) then mode := 16;
                end;
                if mode = 10 then
                        code := StrToInt(s)
                else
                begin
                        s := '0x'+s;
                        Val(s,code,i);
                end;
        end;
        Edit2.Text:=WideString(WideChar(code));

end;

end.
